function UnaryClassifier = UnaryClassifierTrain(featPath, trainList, ...
    classifierPath, gtPath, Model)

classifierName = sprintf('UnaryClassifier_%d_%d.mat', ...
    Model.Nthresholds, Model.UnaryClassifierNum);

if ~exist(fullfile(classifierPath, classifierName), 'file')
    dataNum = length(trainList);
    if ~exist(fullfile(classifierPath, 'UnaryTrain.mat'), 'file')
        feat  = cell(dataNum,1);
        label = cell(dataNum,1);
        for id = 1 : dataNum
            trainList{id},
            load(fullfile(featPath, [trainList{id}, '.mat']), 'vidfeat');
            load(fullfile(gtPath, [trainList{id}, '.mat']), 'bkGT');
            frm = min(size(vidfeat, 3), size(bkGT, 3));
            vidfeat = vidfeat(:,:,1:frm,:);
            bkGT    = bkGT(:,:,1:frm,:);
            featitem  = getUnaryData(vidfeat);
            featlabel = getUnaryLabel(bkGT);
            feat{id}  = featitem;
            label{id} = featlabel;
        end
        save(fullfile(classifierPath, 'UnaryTrain.mat'), 'feat', 'label');
    else
        load(fullfile(classifierPath, 'UnaryTrain.mat'), 'feat', 'label');
    end

    TrainMatrix = cell2mat(feat);
    TrainLabel  = cell2mat(label);
    posIdx = find(TrainLabel>=0.5);
    negIdx = find(TrainLabel<0.5);
    TrainLabel(posIdx) = 1;
    TrainLabel(negIdx) = 2;
    
    addpath(genpath('../../others/Adaboost'));

    UnaryClassifier = jointBoosting(TrainMatrix', TrainLabel, Model.T, ...
        Model.UnaryClassifierNum, Model.Nthresholds);

    save(fullfile(classifierPath, classifierName), 'UnaryClassifier');

    rmpath(genpath('../../others/Adaboost'));
    delete('tmp2.mat');
else
    load(fullfile(classifierPath, classifierName), 'UnaryClassifier');
end