function vidfeat = featExtraction(dataPath, dataName, frmPath, Grid, featDim)

    frmdir = fullfile(frmPath, dataName);
    
    frmList = dir(fullfile(frmdir, '*.png'));
    frmnum  = length(frmList);
    frmFeat = zeros(Grid(1), Grid(2), frmnum, featDim);
    
    for id = 1 : frmnum
        im = imread(fullfile(frmdir, frmList(id).name));
        [row, col, chan] = size(im);
        hogfeatI = SimHOG(im, Grid(1),   Grid(2));
        hogfeatII= SimHOG(im, Grid(1)*2, Grid(2)*2);
        hogfeat = zeros(Grid(1), Grid(2), featDim);
        for idr = 1 : Grid(1)
            for idc = 1 : Grid(2)
                featitemI  = hogfeatI(idr, idc, :);
                featitemII = hogfeatII((idr-1)*2+1:idr*2, (idc-1)*2+1:idc*2, :);
                featitem = [featitemI(:); featitemII(:)];
                featitem = featitem/(norm(featitem)+eps);
                hogfeat(idr, idc, :) = featitem;
            end
        end
        frmFeat(:,:,id,:) = hogfeat;
    end
    
    vidfeat = zeros(Grid(1), Grid(2), floor(frmnum/Grid(3)), featDim*8);

    for id = 1 : floor(frmnum/Grid(3))
        startfrm = (id-1)*Grid(3)+1;
        endfrm   = id*Grid(3);
        for idr = 1 : Grid(1)
            for idc = 1 : Grid(2)
                block = squeeze(frmFeat(idr,idc,startfrm:endfrm,:));
                sumF = squeeze(sum(block(1:ceil(Grid(3)/2), :)));
                sumA = squeeze(sum(block(1+ceil(Grid(3)/2):end, :)));
                sumBk = (sumF + sumA)/2;
                difBk = (sumF - sumA);
                featitem = [block(:); sumF'; sumA'; sumBk'; difBk'];
                vidfeat(idr,idc,id,:) = featitem;
            end
        end
    end
    
    