function VtScore = houghVoting(vidfeat, Model)

    [rowbk, colbk, frmbk, featDim] = size(vidfeat);
    VtDist = zeros(rowbk, colbk, frmbk);
    for idf = 1 : frmbk
        for idr = 1 : rowbk
            for idc = 1 : colbk
                featitem = squeeze(vidfeat(idr, idc, idf,:));
                centers = squeeze(Model.Centers(idr,idc,:,:));
                dist = pdist2(featitem', centers);
                [~, idx] = min(dist,[],2);
                VtDist(:,:,idf) = VtDist(:,:,idf) + ...
                    squeeze(Model.Maps(idr, idc,idx, :,:));
            end
        end
        VtDist(:,:,idf) = VtDist(:,:,idf)/rowbk/colbk;
    end
    VtScore = 1 - VtDist;
