function reOrganize(dataList, origtbkPath, oridsbkPath, orifeatPath, ...
           gtbkPath, dsbkPath, featPath)
       
dataNum = length(dataList);

parfor id = 1 : dataNum
    parProcess(id, dataList, origtbkPath, oridsbkPath, orifeatPath, ...
           gtbkPath, dsbkPath, featPath);
end

function parProcess(id, dataList, origtbkPath, oridsbkPath, orifeatPath, ...
           gtbkPath, dsbkPath, featPath)

    dataName = dataList{id};
    if (~exist(fullfile(gtbkPath, [dataName, '.mat'])) & ...
        ~exist(fullfile(dsbkPath, [dataName, '.mat'])) & ...
        ~exist(fullfile(featPath, [dataName, '.mat'])))
        load(fullfile(origtbkPath, [dataName, '.mat']), 'bkGT');
        load(fullfile(oridsbkPath, [dataName, '.mat']), 'dsGT'); 
        load(fullfile(orifeatPath, [dataName, '.mat']), 'vidfeat'); 
        [bkGT, dsGT, vidfeat] = reOrganizeVideo(bkGT, dsGT, vidfeat);
        save(fullfile(gtbkPath, [dataName, '.mat']), 'bkGT');
        save(fullfile(dsbkPath, [dataName, '.mat']), 'dsGT'); 
        save(fullfile(featPath, [dataName, '.mat']), 'vidfeat'); 
    end
