function Centers = CodebookGeneration(featPath, cbPath, trainList, clusterNum)

trainNum = length(trainList);

load(fullfile(featPath, [trainList{1}, '.mat']), 'hogfeat');

[rowbk, colbk, featDim] = size(hogfeat);
Centers = zeros(rowbk, colbk, clusterNum, featDim);

clusterName = sprintf('cb_%dx%dx%d.mat', rowbk, colbk, clusterNum);

if ~exist(fullfile(cbPath, clusterName), 'file')

    addpath(genpath('../../others/kmeans/'));

    for idr = 1 : rowbk
        for idc = 1 : colbk
            feat = zeros(trainNum, featDim);
            for id = 1 : trainNum
                load(fullfile(featPath, [trainList{id}, '.mat']), 'hogfeat');
                feat(id,:) = hogfeat(idr,idc,:);
            end
            [centers,mincenter,mindist,q2,quality] = kmeans(feat,clusterNum,1);
            Centers(idr,idc,:,:) = centers;
        end
    end

    rmpath(genpath('../../others/kmeans/'));

    save(fullfile(cbPath, clusterName), 'Centers');
else
    load(fullfile(cbPath, clusterName), 'Centers');
end