function Map = MapGeneration(featPath, cbPath, dsPath, trainList, clusterNum)

dataNum = length(trainList);

load(fullfile(featPath, [trainList{1}, '.mat']), 'hogfeat');

[rowbk, colbk, featDim] = size(hogfeat);

MapName = sprintf('Map_%dx%dx%d.mat', rowbk, colbk, clusterNum);

if ~exist(fullfile(cbPath, MapName), 'file')

    Map = zeros(rowbk, colbk, clusterNum, rowbk, colbk);

    clusterName = sprintf('cb_%dx%dx%d.mat', rowbk, colbk, clusterNum);
    load(fullfile(cbPath, clusterName), 'Centers');

    for idr = 1 : rowbk
        for idc = 1 : colbk
            feat = zeros(dataNum, featDim);
            for id = 1 : dataNum
                load(fullfile(featPath, [trainList{id}, '.mat']), ...
                    'hogfeat');
                feat(id,:) = hogfeat(idr,idc,:);
            end
            centers = squeeze(Centers(idr,idc,:,:));
            dist = pdist2(feat, centers);
            [~, idx] = min(dist,[],2);
            cateIdx = unique(idx);
            for idt = 1 : length(cateIdx)
                vidx = find(idx==cateIdx(idt));
                mapitem = zeros(rowbk, colbk);
                if (length(vidx) > 0)
                    for idv = 1 :length(vidx)
                        load(fullfile(dsPath, [trainList{vidx(idv)}, ...
                            '.mat']), 'dsGT');
                        mapitem = mapitem + dsGT;
                    end
                    Map(idr,idc,cateIdx(idt),:,:) = mapitem/length(vidx);
                end
            end
        end
    end
    save(fullfile(cbPath, MapName), 'Map');

else
    load(fullfile(cbPath, MapName), 'Map');
end