function hogfeat= SimHOG(im, rownum, colnum)

basicdim = 9;

if size(im,3)>1
    im = rgb2gray(im);
end

[row, col] = size(im);

steprow = ceil(row/(rownum));
stepcol = ceil(col/(colnum));

stdrow = steprow*(rownum);
stdcol = stepcol*(colnum);

im = double(imresize(im, [stdrow stdcol]));

dx = [-1,0,1];
dy = -dx';
grad_xr   = imfilter(double(im),dx);
grad_yc   = imfilter(double(im),dy);
angles    = atan2(grad_yc, grad_xr);
magnitude = ((grad_xr.^2)+(grad_yc.^2)).^(0.5);

hogfeat = zeros(rownum, colnum, basicdim);

rs = 1 : steprow : stdrow;
re = steprow : steprow : stdrow;

cs = 1 : stepcol : stdcol;
ce = stepcol: stepcol : stdcol;

range = -pi : 2*pi/basicdim : pi;
range(end) = 2*pi;

for idr = 1 : rownum
    for idc = 1 : colnum

        anglesitem    = angles(rs(idr):re(idr),cs(idc):ce(idc));
        magnitudeitem = magnitude(rs(idr):re(idr),cs(idc):ce(idc));
        
        anglesitem    = anglesitem(:);
        magnitudeitem = magnitudeitem(:);
        
        [binnum, binindex] = histc(anglesitem, range); 
        
        ubin = unique(binindex);
        featitem = zeros(basicdim, 1);
        for idb = 1 : length(ubin)
            featitem(idb,1) = ...
                sum(magnitudeitem(find(binindex==ubin(idb))));
        end
        featitem = featitem./(sum(featitem)+eps); % L1, L2 norm
        hogfeat(idr,idc,:) = featitem;
    end
end

