function hogfeat = featExtraction(dataPath, dataName, Grid, featDim)

    im = imread(fullfile(dataPath, dataName));
	[row, col, chan] = size(im);
	hogfeatI = SimHOG(im, Grid(1),   Grid(2));
	hogfeatII= SimHOG(im, Grid(1)*2, Grid(2)*2);
	hogfeat = zeros(Grid(1), Grid(2), featDim);
	for idr = 1 : Grid(1)
        for idc = 1 : Grid(2)
            featitemI  = hogfeatI(idr, idc, :);
            featitemII = hogfeatII((idr-1)*2+1:idr*2, (idc-1)*2+1:idc*2, :);
            featitem = [featitemI(:); featitemII(:)];
            featitem = featitem/(norm(featitem)+eps);
            hogfeat(idr, idc, :) = featitem;
        end
	end