function [dataList, trainList, testList, trainIdx, testIdx] = ...
    getSplit_stanford40(trainTxtPath, testTxtPath)

formatSpec = '%s%[^\n\r]';
delimiter = '';
fileID = fopen(trainTxtPath,'r');
dataArray = textscan(fileID, formatSpec, 'Delimiter', delimiter, 'EmptyValue' ,NaN, 'ReturnOnError', false);
trainList = dataArray{1};
fclose(fileID);

fileID = fopen(testTxtPath,'r');
dataArray = textscan(fileID, formatSpec, 'Delimiter', delimiter, 'EmptyValue' ,NaN, 'ReturnOnError', false);
testList = dataArray{1};
fclose(fileID);

dataList = [trainList; testList];

trainList = sort(trainList);
testList  = sort(testList);
dataList  = sort(dataList);

trainIdx = zeros(length(trainList), 1);
testIdx  = zeros(length(testList),  1);

trainId = 1;
testId  = 1;
dataId  = 1;

while(dataId<=length(dataList)) 
    if strcmp(trainList{trainId}, dataList{dataId})
        trainIdx(trainId) = dataId;
        trainId = trainId+1;  
    else
        testIdx(testId) = dataId;
        testId = testId+1;
    end 
    dataId  = dataId+1;
end