function VtScore = houghVoting(hogfeat, Model)

    [rowbk, colbk, featDim] = size(hogfeat);
    VtDist = zeros(rowbk, colbk);
    for idr = 1 : rowbk
        for idc = 1 : colbk
            featitem = squeeze(hogfeat(idr, idc, :));
            centers = squeeze(Model.Centers(idr,idc,:,:));
            dist = pdist2(featitem', centers);
            [~, idx] = min(dist,[],2);
            VtDist = VtDist + ...
                    squeeze(Model.Maps(idr, idc, idx, :,:));
        end
    end
	VtDist = VtDist/rowbk/colbk;
    VtScore = 1 - VtDist;
