function Centers = CodebookGeneration(featPath, cbPath, trainList, clusterNum)

trainNum = length(trainList);

load(fullfile(featPath, [trainList{1}, '.mat']), 'vidfeat');

[rowbk, colbk, ~, featDim] = size(vidfeat);
Centers = zeros(rowbk, colbk, clusterNum, featDim);

clusterName = sprintf('cb_%dx%dx%d.mat', rowbk, colbk, clusterNum);

if ~exist(fullfile(cbPath, clusterName), 'file')

    addpath(genpath('../../others/kmeans/'));
    
    for idr = 1 : rowbk
        for idc = 1 : colbk
            feat = {};
            for id = 1 : length(trainList)
                load(fullfile(featPath, [trainList{id}, '.mat']), 'vidfeat');
                featLine = squeeze(vidfeat(idr,idc,:,:));
                feat = [feat; featLine];
            end
            feat = cell2mat(feat);
            [centers,mincenter,mindist,q2,quality] = kmeans(feat,clusterNum,1);
            Centers(idr,idc,:,:) = centers;
        end
    end

    rmpath(genpath('../../others/kmeans/'));

    save(fullfile(cbPath, clusterName), 'Centers');
else
    load(fullfile(cbPath, clusterName), 'Centers');
end
