function [meanAP, AP] = ListEvaluation(List, dataPath, featPath, gtbkPath, hvPath, frmPath, Model, scorePath)

parfor id = 1 : length(List)
    parProcess(List{id}, dataPath, featPath, gtbkPath, hvPath, frmPath, Model, scorePath)
end

AP = zeros(length(List), 1);

for id = 1 : length(List)
    load(fullfile(scorePath, [List{id}, '.mat']), 'ap');
    AP(id,1) = ap;
end

meanAP = mean(AP);

function parProcess(dataName, dataPath, featPath, gtbkPath, hvPath, frmPath, Model, scorePath)

    RankScore = Evaluation(dataName, dataPath, featPath, frmPath, hvPath, Model);
    ap = getAP(RankScore, gtbkPath, dataName);
    txt = sprintf('Data : %s, ap: %f', dataName, ap);
    save(fullfile(scorePath, [dataName, '.mat']), 'RankScore', 'ap');