function Map = MapGeneration(featPath, cbPath, dsPath, trainList, clusterNum)

dataNum = length(trainList);

load(fullfile(featPath, [trainList{1}, '.mat']), 'vidfeat');

[rowbk, colbk, ~, featDim] = size(vidfeat);

MapName = sprintf('Map_%dx%dx%d.mat', rowbk, colbk, clusterNum);

if ~exist(fullfile(cbPath, MapName), 'file')

    Map = zeros(rowbk, colbk, clusterNum, rowbk, colbk);

    clusterName = sprintf('cb_%dx%dx%d.mat', rowbk, colbk, clusterNum);
    load(fullfile(cbPath, clusterName), 'Centers');

    for idr = 1 : rowbk
        for idc = 1 : colbk
            bkNum = 0;
            feat = {};
            for id = 1 : dataNum
                load(fullfile(featPath, [trainList{id}, '.mat']), 'vidfeat');
                load(fullfile(dsPath, [trainList{id}, '.mat']), 'dsGT');
                frm = min(size(dsGT,3), size(vidfeat,3));
                featItem = squeeze(vidfeat(idr, idc, 1:frm, :));
                feat{id} = featItem;
                bkNum = bkNum + frm;
            end
            feat = feat'; feat = cell2mat(feat);
            ds = zeros(rowbk, colbk, bkNum);
            bkidx = 1;
            for id = 1 : dataNum
                load(fullfile(dsPath, [trainList{id}, '.mat']), 'dsGT');
                ds(:,:,bkidx:bkidx+size(dsGT,3)-1) = dsGT;
                bkidx = bkidx+size(dsGT,3);
            end
            centers = squeeze(Centers(idr,idc,:,:));
            dist = pdist2(feat, centers);
            [~, idx] = min(dist,[],2);
            cateIdx = unique(idx);
            for idt = 1 : length(cateIdx)
                vidx = find(idx==cateIdx(idt));
                mapitem = zeros(rowbk, colbk);
                if (length(vidx) > 0)
                    mapitem = sum(ds(:,:,vidx), 3);
                    Map(idr,idc,cateIdx(idt),:,:) = mapitem/length(vidx);
                end
            end
        end
    end
    save(fullfile(cbPath, MapName), 'Map');

else
    load(fullfile(cbPath, MapName), 'Map');
end